      program sacgfs
c 
c...converts binary SAC file into GFS file
c
c... this routine despikes the GEOSCOPE data if read
c... with RDSEED (ised=1)
c    ised=1: read data with RDSEED or ftp-ed SAC files
c    ised=2: read data with SEED91
c    ised=3: data read with ah2sac (Barbara's data)
c    ised=4: read TERRASCOPE data (just to get right network type
c            at ambiguous stations
c    ised=0: not sure, old channel naming convention

c this routine puts the network type into the gfs-headers
c don't change this piece of code unless you are sure that
c your reading  routines and the SAC files you deal with
c have that kind of information in the SAC headers.
c The SAC files drawn directly from the DMC (GOPHER)
c sometimes contain the network type. It's in sh(157).
c However, so far, only IDA and GEO provide the network
c type!! gl, June 94

      parameter (nhed=158,lrecw=128,maxw=1800000)   
c{ # words in header, record length
      dimension hed(30)
      character*4 sh(nhed),netw,nchn,ntyp,jchn1,cdum
      character*80 infile
      character*8 knetwk
      common/myhd$/nscan,nsta,nchn,ntyp,iy,id,ih,im,sec,dt
      common/dat/buf(maxw)
      equivalence (nscan,hed)
      equivalence (sh(1),ddt),(sh(71),jy),(sh(72),jd), (sh(73),jh)
      equivalence (sh(74),jm),(sh(75),js),(sh(76),jms)
      equivalence (sh(80),jpts)
      equivalence (sh(111),jsta),(sh(151),jchn1)
c     equivalence (sh(152),knetwk)

      data ityp/1/,ifl/0/

      call gfs_opena(1,'enter gfs output file..:',ityp,jret) 
      call gfs_erase(1)
      print*, 'Enter for SAC output from rdseed(1),seed91(2)'
      print*,'                           ah2sac(3),else(0)'
      read(*,*) ised

    1 print*,'enter sac file pathname:'
      read(*,'(a)') infile
      leni=lenstr(infile)
      if (leni.eq.0) goto 20
c     write(*,'(a)') 'infile(28:30) = ',infile(28:30)
c... The next seven lines are only needed, if an old version
c... of RDSEED is used where the channel name is not
c... transferred to the SAC header
c     if (ised.eq.1) then 
c         if (infile(27:27).eq.'.') then
c         nchn = infile(28:30)
c         else 
c         nchn = infile(29:31)
c         endif
c      endif
c... the next three lines are needed because the current
c... version of SEED91 does not put the channel name into
c... the SAC header
      if (ised.eq.2) then
         nchn = infile(6:8)
      endif
c
c open sac file
c mode=-4 opens file 'infile' on unit 'lund'
      mode=4
c      lundi=7
      call getfil(mode,lundi,infile,istat)
      if(istat.lt.0) print*,'open segy file error',istat
c           
c read sac header 
      nwrds=nhed
      call rddisc(lundi,sh,nwrds,istat)
      if(istat.lt.nwrds) print*,'error on read',istat,nwrds

c... you need the next few lines if data were converted
c... by ah2sac, june 93, g.l.
c... comment: sometimes, if a time was exactly zero, one
c...          of the routines reading Barbara's data
c...          screwed up.

      if(ised.eq.3)then
      write(cdum,'(a4)')-12345
      do 6 i=71,80 
         if(sh(i).eq.cdum)then
           print*,'header error: element now zero'
           print 6666,jsta,i
           write(sh(i),'(a4)')0
         endif
6666  format(a4,i5)
6     continue
      endif
                          
      nscan= jpts         

c     do 11 i=1,158
c     print 900,'SEED/SAC header: ',i,sh(i)
 900  format(a,i4,a4)
c11   continue
c     print 900,'SEED/SAC header: ',151,sh(151)
c     print 900,'SEED/SAC header: ',152,sh(152)
c     print 900,'SEED/SAC header: ',157,sh(157)
c

c read in data
      nwrds=nscan
      call rddisc(lundi,buf,nwrds,istat)
      if(istat.lt.nwrds) print*,'error reading data ',istat

c...unscramble header
c     print 100,sh                          
c100  format(20a4)
      nsta = jsta             
      if(ised.ne.2)nchn=jchn1

      if(ised.eq.3)then
        write(cdum,'(a4)')jsta
        idum=ichar(cdum(4:4))
        if(idum.lt.47.or.idum.gt.90)then
          cdum(4:4)=' '
          read(cdum,'(a4)')nsta
        endif
        if(jchn1.eq.'VLPE')nchn='VHE '
        if(jchn1.eq.'VLPN')nchn='VHN '
        if(jchn1.eq.'VLPZ')nchn='VHZ '
        if(jchn1.eq.'LP_Z')nchn='LHZ '
        if(jchn1.eq.'LP_N')nchn='LHN '
        if(jchn1.eq.'LP_E')nchn='LHE '
      endif
c ... now fill in the network type
c..................................

      ntyp = 'xxxx'
      if(ised.eq.2)ntyp='GEO '
      if(ised.eq.1)then
       ntyp(3:4)='  '
       ntyp=infile(24:25)
      endif
      if(ntyp(2:2).eq.'.')ntyp(2:2)=' '
      if(ntyp(1:1).eq.'.')then
        call allgsta(nsta,t0,p0,ntyp)
      endif
c     nchn = 'yyyy'

c     write(*,'(a,a4)') 'jchn1= ',jchn1
c      write(*,'(10(a4,2x))') sh

      if (ised.eq.0) then
      if (jchn1(3:3).eq.'E') nchn='E-W ' 
      if (jchn1(3:3).eq.'N') nchn='N-S ' 
      if (jchn1(3:3).eq.'Z') nchn='VERT' 
        if (ntyp.eq.'STEI') then
           if (jchn1(2:2).eq.'E') nchn='E-W ' 
           if (jchn1(2:2).eq.'N') nchn='N-S ' 
           if (jchn1(2:2).eq.'Z') nchn='VERT' 
        endif
      endif

      iy   = jy
      id   = jd
      ih   = jh
      im   = jm
      sec  = js + 0.001*jms
      dt   = ddt                
c     print*,js,jms
c the next few lines is ancient history from a time when
c the data had to be devided by 1000 in order to be handy.
c If you use old data, then remove the comments or put in
c an additional switch.

c
c....divide data by 1000
c                       
c     do 5 i=1,nscan
c   5    buf(i) = 0.001*buf(i)  
c     write(*,'(a)') knetwk

c... despike data of station WFM if read with RDSEED
      if(ised.eq.1.and.ntyp.eq.'GEO ')then
        do 55 i=2,nscan-1
           if(buf(i).eq.2047.and.buf(i-1).ne.2047.
     &               and.buf(i+1).ne.2047)then
             buf(i)=(buf(i-1)+buf(i+1))/2.
           endif
 55     continue
      endif
     
c... check data if read with ah2sac 
      if(ised.eq.3)then
      do 66 i=1,nscan
         if(buf(i).eq.-12345.)then
           print*,'data'
           print 6666,nsta,i
         endif
 66   continue
      endif
      
      call prhdr(ifl,hed,ityp)
      call gfs_rwentry(1,hed,buf,0,'w')  
c close segy file
c mode=2 releases the unit and close the file
      mode=2
      call frefil(mode,lundi,istat)
      if(istat.lt.0) print*,'close segy file error',istat
      goto 1           
   20 call gfs_close(1)                 
c
      stop
      end



      function lenstr(c)
c   lenstr returns the length of the character string c.  The string is defined
c to end by either a blank or a null character.  The end of the string is also
c detected when the length of the string is exceeded.

      character*(*) c

      m=len(c)
      n=1
   10 if(n.gt.m) go to 20
      if(c(n:n).eq.' '.or.c(n:n).eq.char(0)) go to 20
      n=n+1
      go to 10
   20 n=n-1
      lenstr=n
      end
